if(MINGW)
    set(__USE_MINGW_ANSI_STDIO 1)
    set(STDC_HEADERS 1)
endif(MINGW)
if(WIN32)
    set(WIN32_TARGET_DLL 1)
    set(USE_WINDOWS_API 1)
    set(TYPEOF_SF_COUNT_T long)
    # on windows, long is always the same
    set(SF_COUNT_MAX "2147483647")
    set(CPU_IS_BIG_ENDIAN 0)
    set(CPU_IS_LITTLE_ENDIAN 1)
    set(ENABLE_EXPERIMENTAL_CODE 1)
    set(SIZEOF_SF_COUNT_T 4)
    set(CPU_CLIPS_POSITIVE 1)
    set(CPU_CLIPS_NEGATIVE 1)
endif(WIN32)

# Set to 1 if you have libsqlite3. */
#cmakedefine HAVE_SQLITE3
# Will be set to 1 if flac, ogg and vorbis are available. */
#cmakedefine HAVE_EXTERNAL_LIBS
#cmakedefine HAVE_FLAC_LIBS
# Define to 1 if you have the `gmtime_r' function. */
#cmakedefine HAVE_GMTIME_R
# Define to 1 if you have the `gettimeofday' function. */
#cmakedefine HAVE_GETTIMEOFDAY
# Define to 1 if you have the `gmtime' function. */
#cmakedefine HAVE_GMTIME
# Set to 1 if the compile supports the struct hack. */
#cmakedefine HAVE_FLEXIBLE_ARRAY
# Set to 1 if S_IRGRP is defined. */
#cmakedefine HAVE_DECL_S_IRGRP
# Define to 1 if you have the `fsync' function. */
#cmakedefine HAVE_FSYNC

include(CheckTypeSize)
include(CheckIncludeFile)
check_include_file("alsa/asoundlib.h" HAVE_ALSA_ASOUNDLIB_H)
check_include_file("byteswap.h" HAVE_BYTESWAP_H)
check_include_file("dlfcn.h" HAVE_DLFCN_H)
check_include_file("endian.h" HAVE_ENDIAN_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("locale.h" HAVE_LOCALE_H)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("stdlib.h" HAVE_STDLIB_H)
check_include_file("strings.h" HAVE_STRINGS_H)
check_include_file("string.h" HAVE_STRING_H)
check_include_file("sys/stat.h" HAVE_SYS_STAT_H)
check_include_file("sys/time.h" HAVE_SYS_TIME_H)
check_include_file("sys/types.h" HAVE_SYS_TYPES_H)
check_include_file("sys/wait.h" HAVE_SYS_WAIT_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_include_file("memory.h" HAVE_MEMORY_H)

check_type_size("double" SIZEOF_DOUBLE)
check_type_size("float" SIZEOF_FLOAT)
check_type_size("int" SIZEOF_INT)
check_type_size("int64_t" SIZEOF_INT64_T)
check_type_size("loff_t" SIZEOF_LOFF_T)
check_type_size("long" SIZEOF_LONG)
check_type_size("long long" SIZEOF_LONG_LONG)
check_type_size("off64_t" SIZEOF_OFF64_T)
check_type_size("off_t" SIZEOF_OFF_T)
check_type_size("short" SIZEOF_SHORT)
check_type_size("size_t" SIZEOF_SIZE_T)
check_type_size("ssize_t" SIZEOF_SSIZE_T)
check_type_size("void*" SIZEOF_VOIDP)
check_type_size("wchar_t" SIZEOF_WCHAR_T)

configure_file(src/config.h.cmake config.h)
configure_file(src/sndfile.h.in   sndfile.h)
